GpgFrontend Project A Free, Powerful, Easy-to-Use, Compact, Cross-Platform, and Installation-Free OpenPGP(pgp) Crypto Tool.

Public Member Functions | Private Attributes | List of all members
GpgFrontend::GpgUIDOperator Class Reference
Inheritance diagram for GpgFrontend::GpgUIDOperator:
Collaboration diagram for GpgFrontend::GpgUIDOperator:

## Public Member Functions
| GpgUIDOperator (int channel=SingletonFunctionObject::GetDefaultChannel())
| Construct a new Gpg UID Opera object. More...
bool | AddUID (const GpgKey &key, const std::string &uid)
bool | AddUID (const GpgKey &key, const std::string &name, const std::string &comment, const std::string &email)
bool | RevUID (const GpgKey &key, const std::string &uid)
bool | SetPrimaryUID (const GpgKey &key, const std::string &uid)
Public Member Functions inherited from GpgFrontend::SingletonFunctionObject< GpgUIDOperator >
int | GetChannel () const
| Get the Channel object. More...
| SingletonFunctionObject (GpgUIDOperator &&)=delete
| Construct a new Singleton Function Object object. More...
| SingletonFunctionObject (const GpgUIDOperator &)=delete
| Construct a new Singleton Function Object object. More...
void | operator= (const GpgUIDOperator &)=delete

## Private Attributes
GpgContext & | ctx_

## Additional Inherited Members
Static Public Member Functions inherited from GpgFrontend::SingletonFunctionObject< GpgUIDOperator >
static GpgUIDOperator & | GetInstance (int channel=GpgFrontend::GPGFRONTEND_DEFAULT_CHANNEL)
| Get the Instance object. More...
static GpgUIDOperator & | CreateInstance (int channel, std::function< std::unique_ptr< GpgUIDOperator >(void)> factory)
| Create a Instance object. More...
static GpgUIDOperator & | CreateInstance (int channel, std::unique_ptr< GpgUIDOperator > p_obj=nullptr)
| Create a Instance object. More...
static GpgUIDOperator & | ReleaseChannel (int channel)
static int | GetDefaultChannel ()
| Get the Default Channel object. More...
Protected Member Functions inherited from GpgFrontend::SingletonFunctionObject< GpgUIDOperator >
| SingletonFunctionObject ()=default
| Construct a new Singleton Function Object object. More...
| SingletonFunctionObject (int channel)
| Construct a new Singleton Function Object object. More...
virtual | ~SingletonFunctionObject ()=default
| Destroy the Singleton Function Object object. More...
void | SetChannel (int channel)
| Set the Channel object. More...

## Constructor & Destructor Documentation

## ◆ GpgUIDOperator()

GpgFrontend::GpgUIDOperator::GpgUIDOperator | ( | int | channel = `SingletonFunctionObject::GetDefaultChannel()` | ) |
| explicit

Construct a new Gpg UID Opera object.

Parameters

  channel | Copyright (C) 2021 Saturneric

This file is part of GpgFrontend.

GpgFrontend is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

GpgFrontend is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with GpgFrontend. If not, see https://www.gnu.org/licenses/.

The initial version of the source code is inherited from the gpg4usb project, which is under GPL-3.0-or-later.

All the source code of GpgFrontend was modified and released by Saturnericeric@.nosp@m.bktu.nosp@m.s.com starting on May 12, 2021.

SPDX-License-Identifier: GPL-3.0-or-later

## Member Function Documentation

## ◆ AddUID() [1/2]

bool GpgFrontend::GpgUIDOperator::AddUID | ( | const GpgKey & | key,
|  | const std::string & | name,
|  | const std::string & | comment,
|  | const std::string & | email
| ) |  |

create a new uid in certain key pair

Parameters

  key | target key pair
  name |
  comment |
  email |

Returns

## ◆ AddUID() [2/2]

bool GpgFrontend::GpgUIDOperator::AddUID | ( | const GpgKey & | key,
|  | const std::string & | uid
| ) |  |

create a new uid in certain key pair

Parameters

  key | target key pair
  uid | uid args(combine name&comment&email)

Returns
  if successful

References GpgFrontend::check_gpg_error_2_err_code().

## ◆ RevUID()

bool GpgFrontend::GpgUIDOperator::RevUID | ( | const GpgKey & | key,
|  | const std::string & | uid
| ) |  |

Revoke(Delete) UID from certain key pair

Parameters

  key | target key pair
  uid | target uid

Returns
  if successful

References GpgFrontend::check_gpg_error(), and GpgFrontend::check_gpg_error_2_err_code().

## ◆ SetPrimaryUID()

bool GpgFrontend::GpgUIDOperator::SetPrimaryUID | ( | const GpgKey & | key,
|  | const std::string & | uid
| ) |  |

Set one of a uid of a key pair as primary

Parameters

  key | target key pair
  uid | target uid

Returns
  if successful

References GpgFrontend::check_gpg_error(), and GpgFrontend::check_gpg_error_2_err_code().

## Member Data Documentation

## ◆ ctx_

GpgContext& GpgFrontend::GpgUIDOperator::ctx_
| private

Initial value:
=
GpgContext::GetInstance(SingletonFunctionObject::GetChannel())

The documentation for this class was generated from the following files:

- src/core/function/gpg/GpgUIDOperator.h
- src/core/function/gpg/GpgUIDOperator.cpp

GpgFrontend::SingletonFunctionObject< GpgContext >::GetInstance
static GpgContext & GetInstance(int channel=GpgFrontend::GPGFRONTEND_DEFAULT_CHANNEL)
Get the Instance object.
Definition: GpgFunctionObject.h:57
GpgFrontend::SingletonFunctionObject::GetChannel
int GetChannel() const
Get the Channel object.
Definition: GpgFunctionObject.h:134